/*
 * Yggdrasil AGI :: Copyright (C) 1998 Dark Fiber
 */

#ifndef __AGI_KEYBOARD
#define __AGI_KEYBOARD

#ifdef __cplusplus
extern "C"{
#endif

typedef struct AGI_EVENT
{
	UINT8	event;
	UINT8	occured;
	UINT16	data;
} AGI_EVENT;

extern	UINT16		key_pressed;
extern	UINT16		scan_code;

extern	AGI_EVENT	events[];
extern	AGI_WORD	ego_words[];
extern	UINT16		num_ego_words;
extern	UINT8		strings[MAX_WORDS1][MAX_WORDS2];

extern	void	init_words(void);
extern	void	clean_input(void);
extern	void	poll_keyboard(void);
extern	UINT8	*get_string(UINT16 x, UINT16 y, UINT16 len);
extern	UINT16	agi_get_keypress(void);

#ifdef __cplusplus
};
#endif
#endif
