/*
 * Yggdrasil AGI :: Copyright (C) 1998 Dark Fiber
 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <conio.h>

#include "includes.h"

AGI_MENU	*menu;
AGI_MENU	*master_menu;

void init_menus(void)
{
	menu=(AGI_MENU*)calloc(1, sizeof(AGI_MENU));
	master_menu=NULL;
}

void deinit_menus(void)
{
	AGI_MENU	*m0, *m1, *m2;

	/* free all down's then all next's */

	m0=menu->next;
	while(m0!=NULL)
	{
		m1=m0->down;
		while(m1!=NULL)
		{
			m2=m1->down;
			if(m1->text!=NULL)
				free(m1->text);
			free(m1);
			m1=m2;
		}

		m1=m0->next;
		if(m0->text!=NULL)
			free(m0->text);
		free(m0);
		m0=m1;
	}

	free(menu);
}


void add_menu(UINT8 *message)
{
	AGI_MENU	*m1=menu;

	while(m1->next!=NULL)
		m1=m1->next;

	m1->next=(AGI_MENU*)calloc(1, sizeof(AGI_MENU));

	m1=m1->next;

	m1->enabled=__TRUE;
	m1->code=0xFF;
	/*m1->text=(UINT8*)strdup((char*)message);*/

	m1->text=(UINT8*)string_dupe((char*)message, __LINE__, __FILE__);
}

void add_menu_item(UINT8 *message, UINT8 code)
{
	AGI_MENU	*m1;

	m1=menu;
	while(m1->next!=NULL)
		m1=m1->next;

	while(m1->down!=NULL)
		m1=m1->down;

	m1->down=(AGI_MENU*)calloc(1, sizeof(AGI_MENU));
	m1=m1->down;

	m1->enabled=__TRUE;
	m1->code=code;
	/*m1->text=(UINT8*)strdup((char*)message);*/
	m1->text=(UINT8*)string_dupe((char*)message, __LINE__, __FILE__);
}

void submit_menu(void)
{
	master_menu=menu;
}
