/*
 * Yggdrasil AGI :: Copyright (C) 1998 Dark Fiber
 */

#ifndef __AGI_PICTURE
#define __AGI_PICTURE

#ifdef __cplusplus
extern "C"{
#endif

typedef struct CORD
{
	struct CORD *next;
	UINT16	x, y;
} CORD;


typedef struct AGI_PICTURE
{
	UINT32	flen;			/* size of raw data */
	UINT8	*rdata;			/* raw vector image data */
	UINT8	*sdata;			/* screen bitmap image */
	UINT8	*pdata;			/* priority bitmap image */
	UINT8	*cdata;			/* control lines image */
	UINT8	*xdata;			/* combined p+c images */
} AGI_PICTURE;

/* kludge */
extern	UINT8			sprite_data[];
extern	UINT8			screen_data[];
extern	UINT8			screen2[];
extern	UINT8			xdata_data[];
extern	UINT8			control_data[];
extern	UINT8			priority_data[];

extern	AGI_PICTURE		pictures[];
extern	UINT16			decode_picture(UINT16 resnum);
extern	UINT16			unload_picture(UINT16 resnum);
extern	UINT8			pic_clear_flag;

extern	void			dump_screen(UINT16 resnum);
extern	void			dump_pri(UINT16 resnum);
extern	void			dump_con(UINT16 resnum);
extern	void			dump_x(UINT16 resnum);

extern	void			dump_pri_screen(void);
extern	void			dump_screenX(void);
extern	void			dump_screen2(void);

extern	UINT8* 			convert_v2_v3_pic(UINT8 *data, UINT32 len);


#ifdef __cplusplus
};
#endif
#endif
