#include <time.h>

#include "includes.h"

SINT32	rnd_seed;

void set_rnd_seed(void)
{
	set_xrnd_seed(time(NULL));
}

SINT32 get_rnd_seed(void)
{
	return rnd_seed;
}

void set_xrnd_seed(SINT32 seedval)
{
	rnd_seed=(seedval%(RNG_M-1))+1;
}

SINT32 xrnd(void)
{
    SINT32 low, high, test;

    high = rnd_seed / RNG_Q;
    low = rnd_seed % RNG_Q;
    test = RNG_A * low - RNG_R * high;
    if(test>0)
    	rnd_seed = test;
    else
    	rnd_seed = test + RNG_M;
	return rnd_seed;
}

SINT32 rnd(SINT32 maxrnd)
{
    if(maxrnd==0L)
    	return xrnd();
    else
    	return((xrnd())%maxrnd);
}
