/*
 * Yggdrasil AGI :: Copyright (C) 1998 Dark Fiber
 */

#ifndef __GLOBAL
#define __GLOBAL

#ifdef __cplusplus
extern "C"{
#endif

extern	UINT8	o_score;
extern	UINT8	o_sound;
extern	UINT8	o_status;

/**************************************************************************/
extern	UINT8	lohi_getbyte(UINT8 *mem);
extern	UINT16	lohi_getword(UINT8 *mem);
extern	UINT32	lohi_getpword(UINT8 *mem);
extern	UINT32	lohi_getdword(UINT8 *mem);

extern	UINT8	hilo_getbyte(UINT8 *mem);
extern	UINT16	hilo_getword(UINT8 *mem);
extern	UINT32	hilo_getpword(UINT8 *mem);
extern	UINT32	hilo_getdword(UINT8 *mem);

extern	void	fixpath(UINT8 flag, UINT8 *fname);

extern	UINT8	getflag(UINT32 number);
extern	void	setflag(UINT32 number, UINT8 value);
extern	void	flipflag(UINT32 number);

extern	UINT8	getvar(UINT32 var);
extern	void	setvar(UINT32 var, UINT8 val);

extern	void	decrypt(UINT8 *mem, UINT32 len);
extern	void	unload_resources(void);
extern	void	release_sprites(void);
extern	void	release_sprite(UINT16 resnum);
extern	void	kill_sprites(void);
extern	void	kill_sprite(UINT16 resnum);
extern	void	new_room_resources(void);
extern	void	update_status_line(UINT8 force);

extern	char*	string_dupe(char *s, int Line, char *File);


#ifdef __cplusplus
};
#endif
#endif
