/*
 * Yggdrasil AGI :: Copyright (C) 1998 Dark Fiber
 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <conio.h>

#include "includes.h"

UINT16		scan_code;				/* scan code */
UINT16		key_pressed;			/* !0 = key pressed in last cycle */
AGI_EVENT	events[MAX_DIRS];		/* keyboard events */

UINT16		num_ego_words;			/* number of words entered */
AGI_WORD	ego_words[MAX_WORDS];	/* words entered by player */

UINT8		strings[MAX_WORDS1][MAX_WORDS2];		/* strings */

void init_words(void)
{
	UINT16	i;

	for(i=0; i<MAX_WORDS; i++)
	{
		/*ego_words[i].word=(UINT8*)strdup((char*)"");*/
		ego_words[i].word=(UINT8*)string_dupe((char*)"", __LINE__, __FILE__);
		ego_words[i].id=0xFFFF;
	}

	key_pressed=__FALSE;
}

void clean_input(void)
{
	UINT16	i;

	for(i=0; i<MAX_WORDS; i++)
	{
		/*
		if(ego_words[i].word!=NULL)
			free(ego_words[i].word);
		*/
		ego_words[i].word=NULL;
		ego_words[i].id=0xFFFF;
	}
	num_ego_words=0;
}

void poll_keyboard(void)
{
	UINT16	key, sc;
	UINT16	c1;

	key_pressed=0x0;
	scan_code=0x0;

	setflag(F_entered_cli, __FALSE);
	setvar(V_key, 0);

	for(c1=0; c1<MAX_DIRS; c1++)
		events[c1].occured=__FALSE;

	/*if(allow_kyb_input==__TRUE)*/
	{
    	/* if a key is ready,  rip it */
    	if(is_keypress()==__TRUE)
    	{
    		key=get_keypress();
    		scan_code=key>>8;
    		key_pressed=key&0xFF;
    		sc=scan_code;
    		key=key_pressed;

			while(is_keypress()==__TRUE)
				get_keypress();

			if(key!=0)
			{
	    		setvar(V_key, key);					/* the key we entered */
	    		setflag(F_entered_cli, __TRUE);		/* we entered a keypress */
	    	}

    		for(c1=0; c1<MAX_DIRS; c1++)
    		{
    			switch(events[c1].event)
    			{
    				default:
    					break;
    				case eSCAN_CODE:
    					if(events[c1].data==sc)
    						events[c1].occured=__TRUE;
    					break;
    				case eKEY_PRESS:
    					if(events[c1].data==key && sc==0x0)
    						events[c1].occured=__TRUE;
    					break;
    			}
    		}

    		if(key<0x100)
    		{
    			/* display on screen,  etc */
    		}
    	}
    }
}


UINT8* get_string(UINT16 x, UINT16 y, UINT16 len)
{
	static UINT8	buff[256];
	UINT8	offs=0;			/* current offset */

	buff[offs]=0;
	while(offs<len)
	{
		/*get_keypress();*/
		key_pressed=getch();
		if(key_pressed==0)
			getch();

		switch(key_pressed)
		{
			case 0x0A:
			case 0x0D:
				offs=len+1;
				break;

			case 0x08:
				if(offs>0)
				{
					offs--;
					x-=8;
					put_text_character(x, y, buff[offs], txt_bg, txt_bg, NO_SAVE);
					buff[offs]=0x0;
				}
				break;

			default:
				if(key_pressed>=0x20 && key_pressed<0x7F)
				{
					if(offs<len-1)
					{
						buff[offs]=key_pressed;
						put_text_character(x, y, buff[offs], txt_fg, txt_bg, NO_SAVE);
						offs++;
						buff[offs]=0;
						x+=8;
					}
				}
				break;
		}
	}
	return (UINT8*)buff;
}

UINT16 agi_get_keypress(void)
{
	UINT16	k;

	if(allow_kyb_input==__TRUE)
	{
		/*return get_keypress();*/
		k=get_keypress();
		scan_code=k>>8;
		key_pressed=k&0xFF;
		return k;
	}
	else
		return 0;
}

