
//by Nicholas Vinen, 1997

#define ENTER                       13
#define ESC                         27
#define BACKSPACE                    8
#define TAB                          9
#define SCAN_SHIFTTAB               15

#define SCAN_LEFT                   75
#define SCAN_RIGHT                  77
#define SCAN_UP                     72
#define SCAN_DOWN                   80
#define SCAN_ALT_LEFT              155
#define SCAN_ALT_RIGHT             157
#define SCAN_ALT_UP                152
#define SCAN_ALT_DOWN              160
#define SCAN_CTRL_LEFT             115
#define SCAN_CTRL_RIGHT            116
#define SCAN_CTRL_UP               141
#define SCAN_CTRL_DOWN             145

#define SCAN_PAGEUP                 73
#define SCAN_PAGEDOWN               81
#define SCAN_CTRL_PAGEUP           132
#define SCAN_CTRL_PAGEDOWN         118
#define SCAN_ALT_PAGEUP            153
#define SCAN_ALT_PAGEDOWN          161
#define SCAN_HOME                   71
#define SCAN_END                    79
#define SCAN_CTRL_HOME             119
#define SCAN_CTRL_END              117
#define SCAN_ALT_HOME              151
#define SCAN_ALT_END               159
#define SCAN_INS                    82
#define SCAN_DEL                    83
#define SCAN_CTRL_INS              146
#define SCAN_CTRL_DEL              147
#define SCAN_ALT_INS               162
#define SCAN_ALT_DEL               163

#define SCAN_NUMERIC_MINUS          74
#define SCAN_NUMERIC_PLUS           78
#define SCAN_CTRL_NUMERIC_MINUS    142
#define SCAN_CTRL_NUMERIC_PLUS     144
#define SCAN_NUMERIC_SLASH         164
#define SCAN_NUMERIC_ASTERISK       55
#define SCAN_CTRL_NUMERIC_SLASH    149
#define SCAN_CTRL_NUMERIC_ASTERISK 150

#define SCAN_FKey                   59
#define SCAN_SHIFT_FKey             84
#define SCAN_CTRL_FKey              94
#define SCAN_ALT_FKey              104

#define SCAN_ALT_OPENBRACKET        26
#define SCAN_ALT_CLOSEBRACKET       27
#define SCAN_ALT_SEMICOLON          39
#define SCAN_ALT_QUOTE              40
#define SCAN_ALT_LESSTHAN           51
#define SCAN_ALT_GREATERTHAN        52
#define SCAN_ALT_MINUS             130
#define SCAN_ALT_PLUS              131

#define SCAN_ALT_A                  30
#define SCAN_ALT_B                  48
#define SCAN_ALT_C                  46
#define SCAN_ALT_D                  32
#define SCAN_ALT_E                  18
#define SCAN_ALT_F                  33
#define SCAN_ALT_G                  34
#define SCAN_ALT_H                  35
#define SCAN_ALT_I                  23
#define SCAN_ALT_J                  36
#define SCAN_ALT_K                  37
#define SCAN_ALT_L                  38
#define SCAN_ALT_M                  50
#define SCAN_ALT_N                  49
#define SCAN_ALT_O                  24
#define SCAN_ALT_P                  25
#define SCAN_ALT_Q                  16
#define SCAN_ALT_R                  19
#define SCAN_ALT_S                  31
#define SCAN_ALT_T                  20
#define SCAN_ALT_U                  22
#define SCAN_ALT_V                  47
#define SCAN_ALT_W                  17
#define SCAN_ALT_X                  45
#define SCAN_ALT_Y                  21
#define SCAN_ALT_Z                  44

#define SCAN_ALT_1                 120
#define SCAN_ALT_2                 121
#define SCAN_ALT_3                 122
#define SCAN_ALT_4                 123
#define SCAN_ALT_5                 124
#define SCAN_ALT_6                 125
#define SCAN_ALT_7                 126
#define SCAN_ALT_8                 127
#define SCAN_ALT_9                 128
#define SCAN_ALT_0                 129
#define SCAN_ALT_SLASH              53
