#
# Makefile for Watcom C/C++ v10.6
#

!include watcom.dep
!include objs.dep

all: ygdrasil.exe

ygdrasil.exe: $(OBJS)
        echo system  $(sys)>test.lnk
        echo $(lflags)>>test.lnk
        echo option  stack=$(stack_size)>>test.lnk
        echo name    ygdrasil.exe>>test.lnk
        echo file    main, global, agi-v2, ibm, agi, cli, words>>test.lnk
        echo file    objects, picture, id, view, logic, gfx>>test.lnk
        echo file    opcodes, keyboard, rand, menu>>test.lnk
        echo file    agi-v3, lzw>>test.lnk
        wlink @test.lnk

dist:
	.symbolic
	@mkdir src
	@cd src
	@del *.cc
	@del *.c
	@del *.h
	@del *.txt
	@copy ..\*.cc
	@copy ..\*.c
	@copy ..\*.h
	@copy ..\agi.txt
	@del copyleft*.*
	@cd ..

clean: .symbolic
	@del *.$(O)
	@del ygdrasil.exe
	@del test.lnk

.after
	@del test.lnk

.cpp.obj :
        $(cp) $(cflags) $^&

.cc.obj :
        $(cp) $(cflags) $^&

.c.obj :
        $(cc) $(cflags) $^&

.asm.obj :
        $(asm) $(aflags) $^&

!include obj.dep
