/*
 * Yggdrasil AGI :: Copyright (C) 1998 Dark Fiber
 */

#ifndef __AGI_MENU
#define __AGI_MENU

#ifdef __cplusplus
extern "C"{
#endif

typedef struct AGI_MENU
{
	struct	AGI_MENU	*next;		/* next along */
	struct	AGI_MENU	*down;		/* next menu under this */
	UINT8				enabled;	/* enabled or disabled */
	UINT8				code;		/* menu code */
	UINT8				*text;		/* text of menu item */
} AGI_MENU;

extern	AGI_MENU	*menu;

extern	void		init_menus(void);
extern	void		deinit_menus(void);
extern	void		add_menu(UINT8 *message);
extern	void		add_menu_item(UINT8 *message, UINT8 code);
extern	void		submit_menu(void);

#ifdef __cplusplus
};
#endif
#endif
